<template>
  <UForm :schema="schema" :state="state" class="space-y-4 md:space-y-6" @submit="onSubmit">
    <UFormGroup label="Email" name="email" class="block mb-2 text-sm font-medium !text-gray-900">
      <UInput type="email" v-model="state.email" placeholder="jhon@example.com" inputClass="!bg-gray-50 !text-gray-900 sm:text-sm rounded-lg block w-full p-2.5" />
    </UFormGroup>
    <UFormGroup label="Password" name="password" class="block mb-2 text-sm font-medium !text-gray-900">
      <UInput type="password" v-model="state.password" placeholder="••••••••" inputClass="!bg-gray-50 !text-gray-900 sm:text-sm rounded-lg block w-full p-2.5" />
    </UFormGroup>
    <p v-if="error" class="text-sm font-light text-red-500">{{ error }}</p>
    <div class="flex items-center justify-between">
      <a href="#" class="text-sm font-medium text-primary-600 hover:underline">
        Mot de passe oublié?
      </a>
    </div>
    <UButton type="submit" :loading="loading" class="w-full text-white bg-primary-600 hover:bg-primary-700 focus:ring-4 focus:outline-none focus:ring-primary-300 font-medium rounded-lg text-sm px-5 py-2.5 text-center">
      Me connecter
    </UButton>
    <p class="text-sm font-light text-gray-500">
      Je n'ai pas de compte? <NuxtLink to="/register" class="font-medium text-primary-600 hover:underline">Je m'inscris</NuxtLink>
    </p>
  </UForm>
</template>
<script setup lang="ts">
import { object, string, type InferType } from 'yup'
import type { FormSubmitEvent } from '#ui/types'
import { useAuthStore } from '~/store/auth'

const schema = object({
  email: string().email('Le format de l\'email est invalide').required('Champ obligatoire'),
  password: string()
      .min(8, 'Dois contenir au moins 8 charactères')
      .required('Champ obligatoire')
})

type Schema = InferType<typeof schema>

const state = reactive({
  email: undefined,
  password: undefined
})

const authStore = useAuthStore()
const { authenticated } = storeToRefs(useAuthStore())
const router = useRouter();
const loading = computed(() => authStore.loading)
const error = computed(() => authStore.error)

async function onSubmit (event: FormSubmitEvent<Schema>) {
  const user = ref({
    email: event.data.email,
    password: event.data.password
  })
  await authStore.authenticateUser(user.value)
  if (authenticated.value) {
    await router.push('/feed')
  }
}
</script>